task votes {
	File merged_vcf
	File vcf_dup
	String sample
	String prefix
	String docker
	String cluster_config
	String disk_size
	
	command <<<
		python /opt/high_confidence_call_vote.py -vcf ${merged_vcf} -dup ${vcf_dup} -sample ${sample} -prefix ${prefix}

		cat ${prefix}_annotated.vcf | grep -v '##' > ${prefix}.txt

		cat ${prefix}.txt | grep '#CHROM' > header

		for i in chr1 chr2 chr3 chr4 chr5 chr6 chr7 chr8 chr9 chr10 chr11 chr12 chr13 chr14 chr15 chr16 chr17 chr18 chr19 chr20 chr21 chr22 chrX
		do
			cat ${prefix}.txt | grep -w $i | cat header - > ${sample}.$i.mendelian.txt
		done

	>>>

	runtime {
		docker:docker
		cluster: cluster_config
		systemDisk: "cloud_ssd 40"
		dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
	}
	output {
		File annotated_vcf = "${prefix}_annotated.vcf"
		File annotated_txt = "${prefix}.txt"
		Array[File] chromo_votes = glob("*.mendelian.txt")
	}
}

